summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
authorBruno Haible <bruno@clisp.org>2005-04-29 17:42:48 +0000
committerBruno Haible <bruno@clisp.org>2009-06-23 12:12:32 +0200
commitc09c9ad31f545f1061082fac15f7545a7fcfef0a (patch)
tree45f91f037806a4ac4e84299c012f84a4fa403a93
parent4dd980791813ae573091ae82cdb7bd7d25b03d0c (diff)
downloadexternal_gettext-c09c9ad31f545f1061082fac15f7545a7fcfef0a.zip
external_gettext-c09c9ad31f545f1061082fac15f7545a7fcfef0a.tar.gz
external_gettext-c09c9ad31f545f1061082fac15f7545a7fcfef0a.tar.bz2
Test that on glibc systems, the gettext() results come out in the correct
encoding for locales that differ only in their encoding.
-rwxr-xr-xgettext-tools/tests/gettext-528
-rw-r--r--gettext-tools/tests/gettext-5-prg.c66
-rw-r--r--gettext-tools/tests/gettext-5.po8
3 files changed, 102 insertions, 0 deletions
diff --git a/gettext-tools/tests/gettext-5 b/gettext-tools/tests/gettext-5
new file mode 100755
index 0000000..beda928
--- /dev/null
+++ b/gettext-tools/tests/gettext-5
@@ -0,0 +1,28 @@
+#! /bin/sh
+
+# Test that on glibc systems, the gettext() results come out in the correct
+# encoding for locales that differ only in their encoding.
+
+tmpfiles=""
+trap 'rm -fr $tmpfiles' 1 2 3 15
+
+# This test works only on glibc systems.
+grep '@GLIBC2@.*yes' ../config.status >/dev/null || exit 77
+
+# This test works only on systems that have a de_DE.ISO-8859-1 and
+# de_DE.UTF-8 locale installed.
+LC_ALL=de_DE.ISO-8859-1 ./testlocale || exit 77
+LC_ALL=de_DE.UTF-8 ./testlocale || exit 77
+
+tmpfiles="$tmpfiles de_DE"
+test -d de_DE || mkdir de_DE
+test -d de_DE/LC_MESSAGES || mkdir de_DE/LC_MESSAGES
+
+: ${MSGFMT=msgfmt}
+${MSGFMT} -o de_DE/LC_MESSAGES/codeset.mo ${top_srcdir}/tests/gettext-5.po
+
+./gettext-5-prg || exit 1
+
+rm -fr $tmpfiles
+
+exit 0
diff --git a/gettext-tools/tests/gettext-5-prg.c b/gettext-tools/tests/gettext-5-prg.c
new file mode 100644
index 0000000..fa80a3e
--- /dev/null
+++ b/gettext-tools/tests/gettext-5-prg.c
@@ -0,0 +1,66 @@
+/* Test program, used by the gettext-5 test.
+ Copyright (C) 2005 Free Software Foundation, Inc.
+
+ This program is free software; you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 2, or (at your option)
+ any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program; if not, write to the Free Software Foundation,
+ Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
+
+/* Written by Bruno Haible <haible@clisp.cons.org>, 2005. */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif
+
+#include <locale.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include "setenv.h"
+
+/* Make sure we use the included libintl, not the system's one. */
+#undef _LIBINTL_H
+#include "libgnuintl.h"
+
+int
+main (void)
+{
+ char *s;
+ int result = 0;
+
+ unsetenv ("LANGUAGE");
+ unsetenv ("OUTPUT_CHARSET");
+ textdomain ("codeset");
+ bindtextdomain ("codeset", ".");
+
+ setlocale (LC_ALL, "de_DE.ISO-8859-1");
+
+ /* Here we expect output in ISO-8859-1. */
+ s = gettext ("cheese");
+ if (strcmp (s, "K\344se"))
+ {
+ fprintf (stderr, "call 1 returned: %s\n", s);
+ result = 1;
+ }
+
+ setlocale (LC_ALL, "de_DE.UTF-8");
+
+ /* Here we expect output in UTF-8. */
+ s = gettext ("cheese");
+ if (strcmp (s, "K\303\244se"))
+ {
+ fprintf (stderr, "call 2 returned: %s\n", s);
+ result = 1;
+ }
+
+ return result;
+}
diff --git a/gettext-tools/tests/gettext-5.po b/gettext-tools/tests/gettext-5.po
new file mode 100644
index 0000000..9a6231d
--- /dev/null
+++ b/gettext-tools/tests/gettext-5.po
@@ -0,0 +1,8 @@
+msgid ""
+msgstr ""
+"MIME-Version: 1.0\n"
+"Content-Type: text/plain; charset=ISO-8859-1\n"
+"Content-Transfer-Encoding: 8-bit\n"
+
+msgid "cheese"
+msgstr "Käse"